#include "Camera.h"
#include <glm/gtc/matrix_transform.hpp>
#include <glm/gtc/type_ptr.hpp>
#include "Engine.h"
// TODO: Only calculate VMAT when it is required to be refreshed (i.e. when player moves)
Camera::Camera(Actor* initTarget) : target(initTarget)
{
	pos = target->GetPos();
	pos += glm::vec3(0.0f, 25.0f, 15.0f); // so we're always looking down at target
	int w = Engine::Instance().GetWindWidth();
	int h = Engine::Instance().GetWindHeight();
	proj = glm::perspective(45.0f, (float)w / (float)h, 0.1f, 1000.0f);
	view = glm::lookAt(pos, target->GetPos(), glm::vec3(0.0f, 1.0f, 0.0f));
}

void Camera::Update() {
	pos = target->GetPos();
	pos += glm::vec3(0.0f, 25.0f, 15.0f); // so we're always looking down at target
	// update the view matrix
	view = glm::lookAt(pos, target->GetPos(), glm::vec3(0.0f, 1.0f, 0.0f));
}

glm::mat4 Camera::GetVPMatrix() const {
	return proj * view;
}
glm::mat4 Camera::GetVMatrix() const {
	return view;
}
glm::mat4 Camera::GetPMatrix() const {
	return proj;
}