#include "World.h"
#include "Engine.h"
// stupid function to make connecting nodes slightly faster
void ConnectNodes(PathfindingNode* a, PathfindingNode* b) {
	a->AddConnection(b);
	b->AddConnection(a);
}
void World::LoadWorld(const std::string& name) {
	ModelManager& mman = Engine::Instance().GetModelMan();

	// manually placed nodes
	PathfindingNode* p1 =  new PathfindingNode(glm::vec3( 16.0f, 0.0f,  4.0f ));
	PathfindingNode* p2 =  new PathfindingNode(glm::vec3(  8.0f, 0.0f,  4.0f ));
	PathfindingNode* p3 =  new PathfindingNode(glm::vec3(  0.0f, 0.0f,  4.0f ));
	PathfindingNode* p4 =  new PathfindingNode(glm::vec3( -8.0f, 0.0f,  4.0f ));
	PathfindingNode* p5 =  new PathfindingNode(glm::vec3(-16.0f, 0.0f,  4.0f ));
	PathfindingNode* p6 =  new PathfindingNode(glm::vec3( 16.0f, 0.0f,  12.0f));
	PathfindingNode* p7 =  new PathfindingNode(glm::vec3(  8.0f, 0.0f,  12.0f));
	PathfindingNode* p8 =  new PathfindingNode(glm::vec3(  0.0f, 0.0f,  12.0f));
	PathfindingNode* p9 =  new PathfindingNode(glm::vec3( -8.0f, 0.0f,  12.0f));
	PathfindingNode* p10 = new PathfindingNode(glm::vec3( 16.0f, 0.0f,  20.0f));
	PathfindingNode* p11 = new PathfindingNode(glm::vec3(  8.0f, 0.0f,  20.0f));
	PathfindingNode* p12 = new PathfindingNode(glm::vec3( -8.0f, 0.0f,  20.0f));
	PathfindingNode* p13 = new PathfindingNode(glm::vec3( 16.0f, 0.0f,  28.0f));
	PathfindingNode* p14 = new PathfindingNode(glm::vec3(  8.0f, 0.0f,  28.0f));
	PathfindingNode* p15 = new PathfindingNode(glm::vec3( -8.0f, 0.0f,  28.0f));
	PathfindingNode* p16 = new PathfindingNode(glm::vec3(-16.0f, 0.0f,  28.0f));
	PathfindingNode* p17 = new PathfindingNode(glm::vec3( 16.0f, 0.0f,  36.0f));
	PathfindingNode* p18 = new PathfindingNode(glm::vec3(  8.0f, 0.0f,  36.0f));
	PathfindingNode* p19 = new PathfindingNode(glm::vec3(  0.0f, 0.0f,  36.0f));
	PathfindingNode* p20 = new PathfindingNode(glm::vec3( -8.0f, 0.0f,  36.0f));
	PathfindingNode* p21 = new PathfindingNode(glm::vec3(-16.0f, 0.0f,  36.0f));

	ConnectNodes(p1, p2);
	ConnectNodes(p2, p3);
	ConnectNodes(p3, p4);
	ConnectNodes(p4, p5);
	ConnectNodes(p1, p6);
	ConnectNodes(p2, p7);
	ConnectNodes(p3, p8);
	ConnectNodes(p4, p9);
	ConnectNodes(p6, p7);
	ConnectNodes(p7, p8);
	ConnectNodes(p8, p9);
	ConnectNodes(p6, p10);
	ConnectNodes(p7, p11);
	ConnectNodes(p9, p12);
	ConnectNodes(p10, p11);
	ConnectNodes(p10, p13);
	ConnectNodes(p11, p14);
	ConnectNodes(p12, p15);
	ConnectNodes(p13, p14);
	ConnectNodes(p15, p16);
	ConnectNodes(p13, p17);
	ConnectNodes(p14, p18);
	ConnectNodes(p15, p20);
	ConnectNodes(p16, p21);
	ConnectNodes(p17, p18);
	ConnectNodes(p18, p19);
	ConnectNodes(p19, p20);
	ConnectNodes(p20, p21);

	nList.push_back(p1);
	nList.push_back(p2);
	nList.push_back(p3);
	nList.push_back(p4);
	nList.push_back(p5);
	nList.push_back(p6);
	nList.push_back(p7);
	nList.push_back(p8);
	nList.push_back(p9);
	nList.push_back(p10);
	nList.push_back(p11);
	nList.push_back(p12);
	nList.push_back(p13);
	nList.push_back(p14);
	nList.push_back(p15);
	nList.push_back(p16);
	nList.push_back(p17);
	nList.push_back(p18);
	nList.push_back(p19);
	nList.push_back(p20);
	nList.push_back(p21);
	for (PathfindingNode* p : nList) {
		// i got the z positions wrong
		// it's easier to offset here than manually edit the pos...
		p->pos.z -= 8.0f;
	}
	Player* player = new Player(p3, mman.GetModel("models/monsters/gunner/tris.md2"));
	aList.push_back(player);
	rList.push_back(player);
	this->player = player;
	mainCam = new Camera(player);

	// other unimportant meshes
	Renderable* lvl = new Renderable(glm::vec3(0.0f, 0.0f, 0.0f), mman.GetModel("models/level/0.obj"));
	aList.push_back(lvl);
	rList.push_back(lvl);
	Renderable* parasite = new Renderable(glm::vec3(15.0f, 0.0f, 0.0f), mman.GetModel("models/monsters/parasite/tris.md2"));
	aList.push_back(parasite);
	rList.push_back(parasite);
	Renderable* tank = new Renderable(glm::vec3(15.0f, 0.0f, 15.0f), mman.GetModel("models/monsters/tank/tris.md2"));
	aList.push_back(tank);
	rList.push_back(tank);
}

void World::Update() {
	// tick each entity in the world
	for (Actor* a : aList) {
		a->Update();
	}
	// get camera to update its own position
	mainCam->Update();
}

Player* World::GetPlayer() {
	return player;
}

std::vector<Renderable*>& World::getRList() {
	return rList;
}
std::vector<PathfindingNode*> World::getNList() const {
	return nList;
}
Camera* World::GetCamera() {
	return mainCam;
}